From f733339714cab022cbbdea06148795d452b183fe Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Mattias=20Engdeg=C3=A5rd?= <mattiase@acm.org>
Date: Sun, 11 Aug 2019 18:11:54 +0200
Subject: [PATCH] Avoid unsigned addend in overflow check (bug#37006)

* src/alloc.c (free_cons): Cast addend to avoid spurious overflow when
consing_until_gc is negative.
---
 src/alloc.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/src/alloc.c b/src/alloc.c
index 5e089311a2..d416d32743 100644
--- a/src/alloc.c
+++ b/src/alloc.c
@@ -2542,7 +2542,8 @@ free_cons (struct Lisp_Cons *ptr)
   ptr->u.s.u.chain = cons_free_list;
   ptr->u.s.car = dead_object ();
   cons_free_list = ptr;
-  if (INT_ADD_WRAPV (consing_until_gc, sizeof *ptr, &consing_until_gc))
+  if (INT_ADD_WRAPV (consing_until_gc, (object_ct) sizeof *ptr,
+                     &consing_until_gc))
     consing_until_gc = OBJECT_CT_MAX;
   gcstat.total_free_conses++;
 }
-- 
2.20.1 (Apple Git-117)

